"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const grayMatter = require("gray-matter");
const pify = require("pify");
const remark = require('remark');
const slug = require('remark-slug');
const hljs = require('remark-highlight.js');
const html = require('remark-html');
const emoji = require('remark-gemoji-to-emoji');
const autolinkHeadings = require('@rigor789/remark-autolink-headings');
const inlineLinks = require('remark-inline-links');
const renderer = remark()
    .use(slug)
    .use(autolinkHeadings, { behaviour: 'wrap' })
    .use(inlineLinks)
    .use(emoji)
    .use([hljs, html], { sanitize: false });
function markdowner(markdownString, opts) {
    return __awaiter(this, void 0, void 0, function* () {
        const defaults = {
            frontmatter: false
        };
        opts = Object.assign(defaults, opts);
        let data = {};
        let content = markdownString;
        if (opts.frontmatter) {
            const parsed = grayMatter(markdownString);
            data = parsed.data;
            content = parsed.content;
        }
        const md = yield pify(renderer.process)(content);
        return Promise.resolve(Object.assign(data, { content: md.contents }));
    });
}
exports.markdowner = markdowner;
//# sourceMappingURL=index.js.map